-----------------------------------------------------------------------------------------------
-- Client Lua Script for CombatLogFix
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- CombatLogFix Module Definition
-----------------------------------------------------------------------------------------------
local CombatLogFix = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function CombatLogFix:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function CombatLogFix:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- CombatLogFix OnLoad
-----------------------------------------------------------------------------------------------
function CombatLogFix:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("CombatLogFix.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- CombatLogFix OnDocLoaded
-----------------------------------------------------------------------------------------------
function CombatLogFix:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "CombatLogFixForm", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
	    self.wndMain:Show(false, true)
		self:FixLog()

		-- if the xmlDoc is no longer needed, you should set it to nil
		-- self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)


		-- Do additional Addon initialization here
	--	self:FixLog()
	end
end

-----------------------------------------------------------------------------------------------
-- CombatLogFix Functions
-----------------------------------------------------------------------------------------------
function CombatLogFix:FixLog()
    local aAddon = Apollo.GetAddon("CombatLog")
    if aAddon == nil then
        return false
    end
    
    Apollo.RemoveEventHandler("CombatLogLifeSteal", aAddon)
    
    aAddon.OnCombatLogLifeSteal = function(tEventArgs)
			if tEventArgs.unitCaster ~= nil then
				local strResult = String_GetWeaselString(Apollo.GetString("CombatLogLifesteal"), tEventArgs.unitCaster:GetName(), tEventArgs.nHealthStolen)
				aAddon:PostOnChannel(string.format("<T TextColor=\"%s\">%s</T>", aAddon:HelperPickColor(tEventArgs), strResult))
			else
				local strResult = String_GetWeaselString(Apollo.GetString("CombatLogLifesteal"), "Someone-Unknown" , tEventArgs.nHealthStolen)
				aAddon:PostOnChannel(string.format("<T TextColor=\"white\">%s</T>", strResult))
			end       -- your changed function code here
    end
    
	Apollo.RegisterEventHandler("CombatLogLifeSteal", 				"OnCombatLogLifeSteal", aAddon)
    return true
end
-----------------------------------------------------------------------------------------------
-- CombatLogFix Instance
-----------------------------------------------------------------------------------------------
local CombatLogFixInst = CombatLogFix:new()
CombatLogFixInst:Init()
